/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.bizframe.impl;

import org.tinygroup.bizframe.PermissionManager;
import org.tinygroup.bizframe.PermissionObject;
import org.tinygroup.bizframe.PermissionCheckStrategy;
import org.tinygroup.bizframe.PermissionSubject;

/**
 * 可以设置允许和禁止，如果即设置允许又设置了禁止，则禁止
 * 
 * @author luoguo
 * 
 */
@SuppressWarnings("rawtypes")
public class PermissionStrategyBlockFirst implements PermissionCheckStrategy {

	private PermissionManager permissionManager;

	public void setPermissionManager(PermissionManager permissionManager) {
		this.permissionManager = permissionManager;

	}

	public boolean isAllow(PermissionSubject permissionSubject,
			PermissionObject permissionObject) {
		if (isBlock(permissionSubject, permissionObject)) {
			return false;
		} else {
			return permissionManager.isAllowDirectly(permissionSubject,
					permissionObject);
		}
	}

	public boolean isBlock(PermissionSubject permissionSubject,
			PermissionObject permissionObject) {

		return permissionManager.isBlockDirectly(permissionSubject,
				permissionObject);
	}

	public boolean isBlock(String permissionSubjectType,
			String permissionSubjectId, String permissionObjectType,
			String permissionObjectId) {
		return permissionManager.isBlockDirectly(permissionSubjectType,
				permissionSubjectId, permissionObjectType, permissionObjectId);
	}

	public boolean isAllow(String permissionSubjectType,
			String permissionSubjectId, String permissionObjectType,
			String permissionObjectId) {
		if (isBlock(permissionSubjectType, permissionSubjectId,
				permissionObjectType, permissionObjectId)) {
			return false;
		} else {
			return permissionManager.isAllowDirectly(permissionSubjectType,
					permissionSubjectId, permissionObjectType,
					permissionObjectId);
		}
	}

}
